/*
 * Copyright (c) 2018-2022 Digital Bazaar, Inc. All rights reserved.
 */
'use strict';

const bedrock = require('bedrock');
const {config} = bedrock;
require('bedrock-meter-usage-reporter');

const namespace = 'edv-storage';
const cfg = config[namespace] = {};

const basePath = '/edvs';
cfg.routes = {
  basePath
};

// storage size to report to meter service
cfg.storageCost = {
  edv: 1,
  revocation: 1
};

// create dev application identity for edv (must be overridden in deployments)
// ...and `ensureConfigOverride` has already been set via
// `bedrock-app-identity` so it doesn't have to be set here
config['app-identity'].seeds.services.edv = {
  id: 'did:key:z6MkhNyDoLpNcPv5grXoJSJVJjvApd46JU5nPL6cwi88caYW',
  seedMultibase: 'z1AgcCz4zGY5P3covUxqpaGTVs6U12H5aWH1FdyVABCwzkw',
  serviceType: 'edv'
};
